Alembic Version 1.1

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS > Class Template Reference

`#include <ITypedArrayProperty.h>`

Inheritance diagram for Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >:
[legend]
Collaboration diagram for Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >:
[legend]

## Public Types
typedef TRAITS | traits_type
typedef ITypedArrayProperty< TRAITS > | this_type
typedef TRAITS::value_type | value_type
typedef TypedArraySample< TRAITS > | sample_type
typedef shared_ptr< sample_type > | sample_ptr_type
Public Types inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IArrayProperty
typedef IArrayProperty | this_type

## Public Member Functions
| ITypedArrayProperty ()
| ITypedArrayProperty (const ICompoundProperty &iParent, const std::string &iName, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
| ITypedArrayProperty (AbcA::ArrayPropertyReaderPtr iProperty, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
| ITypedArrayProperty (AbcA::ArrayPropertyReaderPtr iProp, WrapExistingFlag iWrapFlag, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
void | get (sample_ptr_type &iVal, const ISampleSelector &iSS=ISampleSelector()) const
sample_ptr_type | getValue (const ISampleSelector &iSS=ISampleSelector()) const
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IArrayProperty
| IArrayProperty ()
| IArrayProperty (const ICompoundProperty &iParent, const std::string &iName, const Argument &iArg0=Argument(), const Argument &iArg1=Argument())
| IArrayProperty (AbcA::ArrayPropertyReaderPtr iPtr, const Argument &iArg0=Argument())
| IArrayProperty (AbcA::ArrayPropertyReaderPtr iPtr, WrapExistingFlag iWrapFlag, const Argument &iArg0=Argument())
| ~IArrayProperty ()
size_t | getNumSamples () const
bool | isConstant () const
bool | isScalarLike () const
| Ask if we are like a scalar - we have 1 and only 1 DataType per sample. More...
AbcA::TimeSamplingPtr | getTimeSampling () const
| Time information. More...
void | get (AbcA::ArraySamplePtr &oSample, const ISampleSelector &iSS=ISampleSelector()) const
void | getAs (void *oSample, AbcA::PlainOldDataType iPod, const ISampleSelector &iSS=ISampleSelector())
| Get a sample into the address of a datum as a particular POD type. More...
void | getAs (void *oSample, const ISampleSelector &iSS=ISampleSelector())
bool | getKey (AbcA::ArraySampleKey &oKey, const ISampleSelector &iSS=ISampleSelector()) const
void | getDimensions (Util::Dimensions &oDim, const ISampleSelector &iSS=ISampleSelector()) const
| Get the dimensions of the datum. More...
ICompoundProperty | getParent () const
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::ArrayPropertyReaderPtr >
const AbcA::PropertyHeader & | getHeader () const
const std::string & | getName () const
AbcA::PropertyType | getPropertyType () const
bool | isScalar () const
bool | isArray () const
bool | isCompound () const
bool | isSimple () const
const AbcA::MetaData & | getMetaData () const
const AbcA::DataType & | getDataType () const
AbcA::TimeSamplingPtr | getTimeSampling () const
IObject | getObject () const
AbcA::ArrayPropertyReaderPtr | getPtr () const
void | reset ()
bool | valid () const
| ALEMBIC_OPERATOR_BOOL (valid())
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
ErrorHandler & | getErrorHandler () const
ErrorHandler::Policy | getErrorHandlerPolicy () const

## Static Public Member Functions
static const char * | getInterpretation ()
static bool | matches (const AbcA::MetaData &iMetaData, SchemaInterpMatching iMatching=kStrictMatching)
static bool | matches (const AbcA::PropertyHeader &iHeader, SchemaInterpMatching iMatching=kStrictMatching)

## Additional Inherited Members
Protected Types inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::ArrayPropertyReaderPtr >
typedef IBasePropertyT< AbcA::ArrayPropertyReaderPtr > | this_type
typedef IBasePropertyT< AbcA::ArrayPropertyReaderPtr > | operator_bool_base_type
Protected Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::ArrayPropertyReaderPtr >
| IBasePropertyT ()
| IBasePropertyT (AbcA::ArrayPropertyReaderPtr iPtr, ErrorHandler::Policy iPolicy)
Protected Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
| Base ()
| Base (ErrorHandler::Policy iPolicy)
| Base (const Base &iCopy)
Base & | operator= (const Base &iCopy)
bool | valid () const
void | reset ()
Protected Attributes inherited from Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::ArrayPropertyReaderPtr >
AbcA::ArrayPropertyReaderPtr | m_property

## Detailed Description

template<class TRAITS>
class Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >

Definition at line 50 of file ITypedArrayProperty.h.

## Member Typedef Documentation

## ◆ sample_ptr_type

template<class TRAITS >

typedef shared_ptr<sample_type> Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::sample_ptr_type

Definition at line 60 of file ITypedArrayProperty.h.

## ◆ sample_type

template<class TRAITS >

typedef TypedArraySample<TRAITS> Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::sample_type

Definition at line 59 of file ITypedArrayProperty.h.

## ◆ this_type

template<class TRAITS >

typedef ITypedArrayProperty<TRAITS> Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::this_type

Definition at line 57 of file ITypedArrayProperty.h.

## ◆ traits_type

template<class TRAITS >

typedef TRAITS Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::traits_type

Definition at line 56 of file ITypedArrayProperty.h.

## ◆ value_type

template<class TRAITS >

typedef TRAITS::value_type Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::value_type

Definition at line 58 of file ITypedArrayProperty.h.

## Constructor & Destructor Documentation

## ◆ ITypedArrayProperty() [1/4]

template<class TRAITS >

Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::ITypedArrayProperty | ( |  | ) |
| inline

Default constructor ...

Definition at line 104 of file ITypedArrayProperty.h.

Referenced by Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::ITypedArrayProperty().

Here is the caller graph for this function:

## ◆ ITypedArrayProperty() [2/4]

template<class TRAITS >

Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::ITypedArrayProperty | ( | const ICompoundProperty & | iParent,
|  | const std::string & | iName,
|  | const Argument & | iArg0 = `Argument()`,
|  | const Argument & | iArg1 = `Argument()`
| ) |  |
| inline

This constructor creates a new typed array property reader. The first argument is the ICompoundProperty parent, from which the error handler policy for inheritance is also derived. The remaining optional arguments can be used to override the ErrorHandlerPolicy, to specify schema matching policy, and that's it.

Definition at line 111 of file ITypedArrayProperty.h.

References ABCA_ASSERT, ALEMBIC_ABC_SAFE_CALL_BEGIN, ALEMBIC_ABC_SAFE_CALL_END_RESET, Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::MetaData::get(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::PropertyHeader::getDataType(), Alembic::Abc::ALEMBIC_VERSION_NS::Base::getErrorHandler(), Alembic::Abc::ALEMBIC_VERSION_NS::Arguments::getErrorHandlerPolicy(), Alembic::Abc::ALEMBIC_VERSION_NS::GetErrorHandlerPolicy(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::PropertyHeader::getMetaData(), Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< PROP_PTR >::getPtr(), Alembic::Abc::ALEMBIC_VERSION_NS::Arguments::getSchemaInterpMatching(), Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::ArrayPropertyReaderPtr >::m_property, Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::matches(), and Alembic::Abc::ALEMBIC_VERSION_NS::ErrorHandler::setPolicy().

Here is the call graph for this function:

## ◆ ITypedArrayProperty() [3/4]

template<class TRAITS >

Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::ITypedArrayProperty | ( | AbcA::ArrayPropertyReaderPtr | iProperty,
|  | const Argument & | iArg0 = `Argument()`,
|  | const Argument & | iArg1 = `Argument()`
| ) |  |
| inline

Explicitly wrap an existing property It will check the data type and also verify the schema, if requested.

Definition at line 153 of file ITypedArrayProperty.h.

References ABCA_ASSERT, ALEMBIC_ABC_SAFE_CALL_BEGIN, ALEMBIC_ABC_SAFE_CALL_END_RESET, Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::MetaData::get(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::PropertyHeader::getDataType(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::PropertyHeader::getMetaData(), Alembic::Abc::ALEMBIC_VERSION_NS::GetSchemaInterpMatching(), Alembic::Abc::ALEMBIC_VERSION_NS::IBasePropertyT< AbcA::ArrayPropertyReaderPtr >::m_property, and Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::matches().

Here is the call graph for this function:

## ◆ ITypedArrayProperty() [4/4]

template<class TRAITS >

Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::ITypedArrayProperty | ( | AbcA::ArrayPropertyReaderPtr | iProp,
|  | WrapExistingFlag | iWrapFlag,
|  | const Argument & | iArg0 = `Argument()`,
|  | const Argument & | iArg1 = `Argument()`
| ) |  |
| inline

Definition at line 178 of file ITypedArrayProperty.h.

References Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::ITypedArrayProperty().

Here is the call graph for this function:

## Member Function Documentation

## ◆ get()

template<class TRAITS >

void Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::get | ( | sample_ptr_type & | iVal,
|  | const ISampleSelector & | iSS = `ISampleSelector()`
| ) |  | const
| inline

Get the typed sample. ...

Definition at line 192 of file ITypedArrayProperty.h.

References Alembic::Abc::ALEMBIC_VERSION_NS::IArrayProperty::get().

Referenced by Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::getValue().

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ getInterpretation()

template<class TRAITS >

static const char * Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::getInterpretation | ( |  | ) |
| inline static

Return the interpretation expected of this property. An empty interpretation matches everything

Definition at line 64 of file ITypedArrayProperty.h.

Referenced by Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::matches().

Here is the caller graph for this function:

## ◆ getValue()

template<class TRAITS >

sample_ptr_type Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::getValue | ( | const ISampleSelector & | iSS = `ISampleSelector()` | ) | const
| inline

Return the typed sample by value. ...

Definition at line 203 of file ITypedArrayProperty.h.

References Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::get().

Here is the call graph for this function:

## ◆ matches() [1/2]

template<class TRAITS >

static bool Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::matches | ( | const AbcA::MetaData & | iMetaData,
|  | SchemaInterpMatching | iMatching = `kStrictMatching`
| ) |  |
| inline static

This will check whether or not a given entity (as represented by a metadata) strictly matches the interpretation of this schema object

Definition at line 72 of file ITypedArrayProperty.h.

References Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::MetaData::get(), Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::getInterpretation(), and Alembic::Abc::ALEMBIC_VERSION_NS::kStrictMatching.

Referenced by Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::ITypedArrayProperty(), Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::matches(), and Alembic::AbcGeom::ALEMBIC_VERSION_NS::ITypedGeomParam< TRAITS >::matches().

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ matches() [2/2]

template<class TRAITS >

static bool Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::matches | ( | const AbcA::PropertyHeader & | iHeader,
|  | SchemaInterpMatching | iMatching = `kStrictMatching`
| ) |  |
| inline static

This will check whether or not a given object (as represented by an object header) strictly matches the interpretation of this schema object

Definition at line 86 of file ITypedArrayProperty.h.

References Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::PropertyHeader::getDataType(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::DataType::getExtent(), Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::getInterpretation(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::PropertyHeader::getMetaData(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::DataType::getPod(), Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::PropertyHeader::isArray(), and Alembic::Abc::ALEMBIC_VERSION_NS::ITypedArrayProperty< TRAITS >::matches().

Here is the call graph for this function:

The documentation for this class was generated from the following file:

- opt/local/include/Alembic/Abc/ITypedArrayProperty.h